Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.squawk.debugger
Class JDWP

    java.lang.Object
      com.sun.squawk.debugger.JDWP

    public class JDWP

extends Object

Java(tm) Debug Wire Protocol

Field Summary
`static int` | `ArrayReference_COMMAND_SET`
`static int` | `ArrayReference_GetValues_COMMAND` Returns a range of array components.
`static int` | `ArrayReference_Length_COMMAND` Returns the number of components in a given array.
`static int` | `ArrayReference_SetValues_COMMAND` Sets a range of array components.
`static int` | `ArrayType_COMMAND_SET`
`static int` | `ArrayType_NewInstance_COMMAND` Creates a new array object of this type with a given length.
`static int` | `ClassLoaderReference_COMMAND_SET`
`static int` | `ClassLoaderReference_VisibleClasses_COMMAND` Returns a list of all classes which this class loader has been requested to load.
`static int` | `ClassObjectReference_COMMAND_SET`
`static int` | `ClassObjectReference_ReflectedType_COMMAND` Returns the reference type reflected by this class object.
`static int` | `ClassStatus_ERROR`
`static int` | `ClassStatus_INITIALIZED`
`static int` | `ClassStatus_PREPARED`
`static int` | `ClassStatus_VERIFIED`
`static int` | `ClassStatus_VERIFIED_PREPARED_INITIALIZED`
`static int` | `ClassType_COMMAND_SET`
`static int` | `ClassType_InvokeMethod_COMMAND` Invokes a static method.
`static int` | `ClassType_NewInstance_COMMAND` Creates a new object of this type, invoking the specified constructor.
`static int` | `ClassType_SetValues_COMMAND` Sets the value of one or more static fields.
`static int` | `ClassType_Superclass_COMMAND` Returns the immediate superclass of a class.
`static int` | `Error_ABSENT_INFORMATION`
`static int` | `Error_ACCESS_DENIED`
`static int` | `Error_ADD_METHOD_NOT_IMPLEMENTED`
`static int` | `Error_ALREADY_INVOKING`
`static int` | `Error_CIRCULAR_CLASS_DEFINITION`
`static int` | `Error_CLASS_MODIFIERS_CHANGE_NOT_IMPLEMENTED`
`static int` | `Error_CLASS_NOT_PREPARED`
`static int` | `Error_DELETE_METHOD_NOT_IMPLEMENTED`
`static int` | `Error_DUPLICATE`
`static int` | `Error_FAILS_VERIFICATION`
`static int` | `Error_HIERARCHY_CHANGE_NOT_IMPLEMENTED`
`static int` | `Error_ILLEGAL_ARGUMENT`
`static int` | `Error_INTERNAL`
`static int` | `Error_INTERRUPT`
`static int` | `Error_INVALID_ARRAY`
`static int` | `Error_INVALID_CLASS`
`static int` | `Error_INVALID_CLASS_FORMAT`
`static int` | `Error_INVALID_CLASS_LOADER`
`static int` | `Error_INVALID_COUNT`
`static int` | `Error_INVALID_EVENT_TYPE`
`static int` | `Error_INVALID_FIELDID`
`static int` | `Error_INVALID_FRAMEID`
`static int` | `Error_INVALID_INDEX`
`static int` | `Error_INVALID_LENGTH`
`static int` | `Error_INVALID_LOCATION`
`static int` | `Error_INVALID_METHODID`
`static int` | `Error_INVALID_MONITOR`
`static int` | `Error_INVALID_OBJECT`
`static int` | `Error_INVALID_PRIORITY`
`static int` | `Error_INVALID_SLOT`
`static int` | `Error_INVALID_STRING`
`static int` | `Error_INVALID_TAG`
`static int` | `Error_INVALID_THREAD`
`static int` | `Error_INVALID_THREAD_GROUP`
`static int` | `Error_INVALID_TYPESTATE`
`static int` | `Error_METHOD_MODIFIERS_CHANGE_NOT_IMPLEMENTED`
`static int` | `Error_NAMES_DONT_MATCH`
`static int` | `Error_NATIVE_METHOD`
`static int` | `Error_NO_MORE_FRAMES`
`static int` | `Error_NONE`
`static int` | `Error_NOT_CURRENT_FRAME`
`static int` | `Error_NOT_FOUND`
`static int` | `Error_NOT_IMPLEMENTED`
`static int` | `Error_NOT_MONITOR_OWNER`
`static int` | `Error_NULL_POINTER`
`static int` | `Error_OPAQUE_FRAME`
`static int` | `Error_OUT_OF_MEMORY`
`static int` | `Error_SCHEMA_CHANGE_NOT_IMPLEMENTED`
`static int` | `Error_THREAD_NOT_SUSPENDED`
`static int` | `Error_THREAD_SUSPENDED`
`static int` | `Error_TRANSPORT_INIT`
`static int` | `Error_TRANSPORT_LOAD`
`static int` | `Error_TYPE_MISMATCH`
`static int` | `Error_UNATTACHED_THREAD`
`static int` | `Error_UNSUPPORTED_VERSION`
`static int` | `Error_VM_DEAD`
`static int` | `Event_COMMAND_SET`
`static int` | `Event_Composite_COMMAND` Several events may occur at a given time in the target VM.
`static int` | `EventKind_BREAKPOINT`
`static int` | `EventKind_CLASS_LOAD`
`static int` | `EventKind_CLASS_PREPARE`
`static int` | `EventKind_CLASS_UNLOAD`
`static int` | `EventKind_EXCEPTION`
`static int` | `EventKind_EXCEPTION_CATCH`
`static int` | `EventKind_FIELD_ACCESS`
`static int` | `EventKind_FIELD_MODIFICATION`
`static int` | `EventKind_FRAME_POP`
`static int` | `EventKind_METHOD_ENTRY`
`static int` | `EventKind_METHOD_EXIT`
`static int` | `EventKind_SINGLE_STEP`
`static int` | `EventKind_THREAD_DEATH`
`static int` | `EventKind_THREAD_END`
`static int` | `EventKind_THREAD_START`
`static int` | `EventKind_USER_DEFINED`
`static int` | `EventKind_VM_DEATH`
`static int` | `EventKind_VM_DISCONNECTED`
`static int` | `EventKind_VM_INIT`
`static int` | `EventKind_VM_START`
`static int` | `EventRequest_Clear_COMMAND` Clear an event request.
`static int` | `EventRequest_ClearAllBreakpoints_COMMAND` Removes all set breakpoints.
`static int` | `EventRequest_COMMAND_SET`
`static int` | `EventRequest_MOD_CLASS_EXCLUDE`
`static int` | `EventRequest_MOD_CLASS_MATCH`
`static int` | `EventRequest_MOD_CLASS_ONLY`
`static int` | `EventRequest_MOD_CONDITIONAL`
`static int` | `EventRequest_MOD_COUNT` Modifier kind values that make events conditional.
`static int` | `EventRequest_MOD_EXCEPTION_ONLY`
`static int` | `EventRequest_MOD_FIELD_ONLY`
`static int` | `EventRequest_MOD_INSTANCE_ONLY`
`static int` | `EventRequest_MOD_LOCATION_ONLY`
`static int` | `EventRequest_MOD_STEP`
`static int` | `EventRequest_MOD_THREAD_ONLY`
`static int` | `EventRequest_Set_COMMAND` Set an event request.
`static int` | `Field_COMMAND_SET`
`static int` | `InterfaceType_COMMAND_SET`
`static int` | `InvokeOptions_INVOKE_NONVIRTUAL`
`static int` | `InvokeOptions_INVOKE_SINGLE_THREADED`
`static int` | `Method_Bytecodes_COMMAND` Retrieve the method's bytecodes as defined in the JVM Specification.
`static int` | `Method_COMMAND_SET`
`static int` | `Method_IsObsolete_COMMAND` Determine if this method is obsolete.
`static int` | `Method_LineTable_COMMAND` Returns line number information for the method.
`static int` | `Method_VariableTable_COMMAND` Returns variable information for the method.
`static int` | `Method_VariableTableWithGeneric_COMMAND` Returns variable information for the method, including generic signatures for the variables.
`static int` | `ObjectReference_COMMAND_SET`
`static int` | `ObjectReference_DisableCollection_COMMAND` Prevents garbage collection for the given object.
`static int` | `ObjectReference_EnableCollection_COMMAND` Permits garbage collection for this object.
`static int` | `ObjectReference_GetValues_COMMAND` Returns the value of one or more instance fields.
`static int` | `ObjectReference_InvokeMethod_COMMAND` Invokes a instance method.
`static int` | `ObjectReference_IsCollected_COMMAND` Determines whether an object has been garbage collected in the target VM.
`static int` | `ObjectReference_MonitorInfo_COMMAND` Returns monitor information for an object.
`static int` | `ObjectReference_ReferenceType_COMMAND` Returns the runtime type of the object.
`static int` | `ObjectReference_SetValues_COMMAND` Sets the value of one or more instance fields.
`static int` | `ReferenceType_ClassLoader_COMMAND` Returns the instance of java.lang.ClassLoader which loaded a given reference type.
`static int` | `ReferenceType_ClassObject_COMMAND` Returns the class object corresponding to this type.
`static int` | `ReferenceType_COMMAND_SET`
`static int` | `ReferenceType_Fields_COMMAND` Returns information for each field in a reference type.
`static int` | `ReferenceType_FieldsWithGeneric_COMMAND` Returns information, including the generic signature if any, for each field in a reference type.
`static int` | `ReferenceType_GetValues_COMMAND` Returns the value of one or more static fields of the reference type.
`static int` | `ReferenceType_Interfaces_COMMAND` Returns the interfaces declared as implemented by this class.
`static int` | `ReferenceType_Methods_COMMAND` Returns information for each method in a reference type.
`static int` | `ReferenceType_MethodsWithGeneric_COMMAND` Returns information, including the generic signature if any, for each method in a reference type.
`static int` | `ReferenceType_Modifiers_COMMAND` Returns the modifiers (also known as access flags) for a reference type.
`static int` | `ReferenceType_NestedTypes_COMMAND` Returns the classes and interfaces directly nested within this type.
`static int` | `ReferenceType_Signature_COMMAND` Returns the JNI signature of a reference type.
`static int` | `ReferenceType_SignatureWithGeneric_COMMAND` Returns the JNI signature of a reference type along with the generic signature if there is one.
`static int` | `ReferenceType_SourceDebugExtension_COMMAND` Returns the value of the SourceDebugExtension attribute.
`static int` | `ReferenceType_SourceFile_COMMAND` Returns the name of source file in which a reference type was declared.
`static int` | `ReferenceType_Status_COMMAND` Returns the current status of the reference type.
`static int` | `StackFrame_COMMAND_SET`
`static int` | `StackFrame_GetValues_COMMAND` Returns the value of one or more local variables in a given frame.
`static int` | `StackFrame_PopFrames_COMMAND` Pop stack frames, thru and including 'frame'.
`static int` | `StackFrame_SetValues_COMMAND` Sets the value of one or more local variables.
`static int` | `StackFrame_ThisObject_COMMAND` Returns the value of the 'this' reference for this frame.
`static int` | `StepDepth_INTO`
`static int` | `StepDepth_OUT`
`static int` | `StepDepth_OVER`
`static int` | `StepSize_LINE`
`static int` | `StepSize_MIN`
`static int` | `StringReference_COMMAND_SET`
`static int` | `StringReference_Value_COMMAND` Returns the characters contained in the string.
`static int` | `SuspendPolicy_ALL`
`static int` | `SuspendPolicy_EVENT_THREAD`
`static int` | `SuspendPolicy_NONE`
`static int` | `SuspendStatus_SUSPEND_STATUS_SUSPENDED`
`static int` | `Tag_ARRAY`
`static int` | `Tag_BOOLEAN`
`static int` | `Tag_BYTE`
`static int` | `Tag_CHAR`
`static int` | `Tag_CLASS_LOADER`
`static int` | `Tag_CLASS_OBJECT`
`static int` | `Tag_DOUBLE`
`static int` | `Tag_FLOAT`
`static int` | `Tag_INT`
`static int` | `Tag_LONG`
`static int` | `Tag_OBJECT`
`static int` | `Tag_SHORT`
`static int` | `Tag_STRING`
`static int` | `Tag_THREAD`
`static int` | `Tag_THREAD_GROUP`
`static int` | `Tag_VOID`
`static int` | `ThreadGroupReference_Children_COMMAND` Returns the threads and thread groups directly contained in this thread group.
`static int` | `ThreadGroupReference_COMMAND_SET`
`static int` | `ThreadGroupReference_Name_COMMAND` Returns the thread group name.
`static int` | `ThreadGroupReference_Parent_COMMAND` Returns the thread group, if any, which contains a given thread group.
`static int` | `ThreadReference_COMMAND_SET`
`static int` | `ThreadReference_CurrentContendedMonitor_COMMAND` Returns the object, if any, for which this thread is waiting for monitor entry or with java.lang.Object.wait.
`static int` | `ThreadReference_FrameCount_COMMAND` Returns the count of frames on this thread's stack.
`static int` | `ThreadReference_Frames_COMMAND` Returns the current call stack of a suspended thread.
`static int` | `ThreadReference_Interrupt_COMMAND` Interrupt the thread, as if done by java.lang.Thread.interrupt
`static int` | `ThreadReference_Name_COMMAND` Returns the thread name.
`static int` | `ThreadReference_OwnedMonitors_COMMAND` Returns the objects whose monitors have been entered by this thread.
`static int` | `ThreadReference_Resume_COMMAND` Resumes the execution of a given thread.
`static int` | `ThreadReference_Status_COMMAND` Returns the current status of a thread.
`static int` | `ThreadReference_Stop_COMMAND` Stops the thread with an asynchronous exception, as if done by java.lang.Thread.stop
`static int` | `ThreadReference_Suspend_COMMAND` Suspends the thread.
`static int` | `ThreadReference_SuspendCount_COMMAND` Get the suspend count for this thread.
`static int` | `ThreadReference_ThreadGroup_COMMAND` Returns the thread group that contains a given thread.
`static int` | `ThreadStatus_MONITOR`
`static int` | `ThreadStatus_RUNNING`
`static int` | `ThreadStatus_SLEEPING`
`static int` | `ThreadStatus_WAIT`
`static int` | `ThreadStatus_ZOMBIE`
`static int` | `TypeTag_ARRAY`
`static int` | `TypeTag_CLASS`
`static int` | `TypeTag_INTERFACE`
`static int` | `VirtualMachine_AllClasses_COMMAND` Returns reference types for all classes currently loaded by the target VM.
`static int` | `VirtualMachine_AllClassesWithGeneric_COMMAND` Returns reference types for all classes currently loaded by the target VM.
`static int` | `VirtualMachine_AllThreads_COMMAND` Returns all threads currently running in the target VM .
`static int` | `VirtualMachine_Capabilities_COMMAND` Retrieve this VM's capabilities.
`static int` | `VirtualMachine_CapabilitiesNew_COMMAND` Retrieve all of this VM's capabilities.
`static int` | `VirtualMachine_ClassesBySignature_COMMAND` Returns reference types for all the classes loaded by the target VM which match the given signature.
`static int` | `VirtualMachine_ClassPaths_COMMAND` Retrieve the classpath and bootclasspath of the target VM.
`static int` | `VirtualMachine_COMMAND_SET`
`static int` | `VirtualMachine_CreateString_COMMAND` Creates a new string object in the target VM and returns its id.
`static int` | `VirtualMachine_Dispose_COMMAND` Invalidates this virtual machine mirror.
`static int` | `VirtualMachine_DisposeObjects_COMMAND` Releases a list of object IDs.
`static int` | `VirtualMachine_Exit_COMMAND` Terminates the target VM with the given exit code.
`static int` | `VirtualMachine_HoldEvents_COMMAND` Tells the target VM to stop sending events.
`static int` | `VirtualMachine_IDSizes_COMMAND` Returns the sizes of variably-sized data types in the target VM.
`static int` | `VirtualMachine_RedefineClassesCOMMAND` Installs new class definitions.
`static int` | `VirtualMachine_ReleaseEvents_COMMAND` Tells the target VM to continue sending events.
`static int` | `VirtualMachine_Resume_COMMAND` Resumes execution of the application after the suspend command or an event has stopped it.
`static int` | `VirtualMachine_SetDefaultStratum_COMMAND` Set the default stratum.
`static int` | `VirtualMachine_Suspend_COMMAND` Suspends the execution of the application running in the target VM.
`static int` | `VirtualMachine_TopLevelThreadGroups_COMMAND` Returns all thread groups that do not have a parent.
`static int` | `VirtualMachine_Version_COMMAND` Returns the JDWP version implemented by the target VM.

Method Summary
`static byte` | `getTag(Klass klass)` Given a klass, returns the corresponding `com.sun.squawk.debugger.JDWP.Tag` value.
`static byte` | `getTypeTag(Klass klass)` Gets the `JDWP.TypeTag_...` value corresponding to a given class.
`static boolean` | `isReferenceTag(int tag)` Return true if the tag represents an reference type JDWP Tag value.
`static boolean` | `isValidTag(int tag)` Return true if the tag is a valid JDWP Tag value.
`static boolean` | `isValidTypeTag(int typeTag)` Return true if the tag is a valid JDWP Type Tag value.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### VirtualMachine_COMMAND_SET

    public static final int VirtualMachine_COMMAND_SET

See Also:
  Constant Field Values

### VirtualMachine_Version_COMMAND

    public static final int VirtualMachine_Version_COMMAND

  Returns the JDWP version implemented by the target VM. The version string format is implementation dependent.

  See Also:
    Constant Field Values

### VirtualMachine_ClassesBySignature_COMMAND

    public static final int VirtualMachine_ClassesBySignature_COMMAND

  Returns reference types for all the classes loaded by the target VM which match the given signature. Multple reference types will be returned if two or more class loaders have loaded a class of the same name. The search is confined to loaded classes only; no attempt is made to load a class of the given signature.

  See Also:
    Constant Field Values

### VirtualMachine_AllClasses_COMMAND

    public static final int VirtualMachine_AllClasses_COMMAND

  Returns reference types for all classes currently loaded by the target VM.

  See Also:
    Constant Field Values

### VirtualMachine_AllThreads_COMMAND

    public static final int VirtualMachine_AllThreads_COMMAND

  Returns all threads currently running in the target VM . The returned list contains threads created through java.lang.Thread, all native threads attached to the target VM through JNI, and system threads created by the target VM. Threads that have not yet been started and threads that have completed their execution are not included in the returned list.

  See Also:
    Constant Field Values

### VirtualMachine_TopLevelThreadGroups_COMMAND

    public static final int VirtualMachine_TopLevelThreadGroups_COMMAND

  Returns all thread groups that do not have a parent. This command may be used as the first step in building a tree (or trees) of the existing thread groups.

  See Also:
    Constant Field Values

### VirtualMachine_Dispose_COMMAND

    public static final int VirtualMachine_Dispose_COMMAND

  Invalidates this virtual machine mirror. The communication channel to the target VM is closed, and the target VM prepares to accept another subsequent connection from this debugger or another debugger, including the following tasks:
  - All event requests are cancelled.
  - All threads suspended by the thread-level resume command or the VM-level resume command are resumed as many times as necessary for them to run.
  - Garbage collection is re-enabled in all cases where it was disabled
  Any current method invocations executing in the target VM are continued after the disconnection. Upon completion of any such method invocation, the invoking thread continues from the location where it was originally stopped.

  Resources originating in this VirtualMachine (ObjectReferences, ReferenceTypes, etc.) will become invalid.

  See Also:
    Constant Field Values

### VirtualMachine_IDSizes_COMMAND

    public static final int VirtualMachine_IDSizes_COMMAND

  Returns the sizes of variably-sized data types in the target VM. The returned values indicate the number of bytes used by the identifiers in command and reply packets.

  See Also:
    Constant Field Values

### VirtualMachine_Suspend_COMMAND

    public static final int VirtualMachine_Suspend_COMMAND

  Suspends the execution of the application running in the target VM. All Java threads currently running will be suspended.

  Unlike java.lang.Thread.suspend, suspends of both the virtual machine and individual threads are counted. Before a thread will run again, it must be resumed through the VM-level resume command or the thread-level resume command the same number of times it has been suspended.

  See Also:
    Constant Field Values

### VirtualMachine_Resume_COMMAND

    public static final int VirtualMachine_Resume_COMMAND

  Resumes execution of the application after the suspend command or an event has stopped it. Suspensions of the Virtual Machine and individual threads are counted. If a particular thread is suspended n times, it must resumed n times before it will continue.

  See Also:
    Constant Field Values

### VirtualMachine_Exit_COMMAND

    public static final int VirtualMachine_Exit_COMMAND

  Terminates the target VM with the given exit code. On some platforms, the exit code might be truncated, for example, to the low order 8 bits. All ids previously returned from the target VM become invalid. Threads running in the VM are abruptly terminated. A thread death exception is not thrown and finally blocks are not run.

  See Also:
    Constant Field Values

### VirtualMachine_CreateString_COMMAND

    public static final int VirtualMachine_CreateString_COMMAND

  Creates a new string object in the target VM and returns its id.

  See Also:
    Constant Field Values

### VirtualMachine_Capabilities_COMMAND

    public static final int VirtualMachine_Capabilities_COMMAND

  Retrieve this VM's capabilities. The capabilities are returned as booleans, each indicating the presence or absence of a capability. The commands associated with each capability will return the NOT_IMPLEMENTED error if the cabability is not available.

  See Also:
    Constant Field Values

### VirtualMachine_ClassPaths_COMMAND

    public static final int VirtualMachine_ClassPaths_COMMAND

  Retrieve the classpath and bootclasspath of the target VM. If the classpath is not defined, returns an empty list. If the bootclasspath is not defined returns an empty list.

  See Also:
    Constant Field Values

### VirtualMachine_DisposeObjects_COMMAND

    public static final int VirtualMachine_DisposeObjects_COMMAND

  Releases a list of object IDs. For each object in the list, the following applies. The count of references held by the back-end (the reference count) will be decremented by refCnt. If thereafter the reference count is less than or equal to zero, the ID is freed. Any back-end resources associated with the freed ID may be freed, and if garbage collection was disabled for the object, it will be re-enabled. The sender of this command promises that no further commands will be sent referencing a freed ID.

  Use of this command is not required. If it is not sent, resources associated with each ID will be freed by the back-end at some time after the corresponding object is garbage collected. It is most useful to use this command to reduce the load on the back-end if a very large number of objects has been retrieved from the back-end (a large array, for example) but may not be garbage collected any time soon.

  IDs may be re-used by the back-end after they have been freed with this command. This description assumes reference counting, a back-end may use any implementation which operates equivalently.

  See Also:
    Constant Field Values

### VirtualMachine_HoldEvents_COMMAND

    public static final int VirtualMachine_HoldEvents_COMMAND

  Tells the target VM to stop sending events. Events are not discarded; they are held until a subsequent ReleaseEvents command is sent. This command is useful to control the number of events sent to the debugger VM in situations where very large numbers of events are generated. While events are held by the debugger back-end, application execution may be frozen by the debugger back-end to prevent buffer overflows on the back end. Responses to commands are never held and are not affected by this command. If events are already being held, this command is ignored.

  See Also:
    Constant Field Values

### VirtualMachine_ReleaseEvents_COMMAND

    public static final int VirtualMachine_ReleaseEvents_COMMAND

  Tells the target VM to continue sending events. This command is used to restore normal activity after a HoldEvents command. If there is no current HoldEvents command in effect, this command is ignored.

  See Also:
    Constant Field Values

### VirtualMachine_CapabilitiesNew_COMMAND

    public static final int VirtualMachine_CapabilitiesNew_COMMAND

  Retrieve all of this VM's capabilities. The capabilities are returned as booleans, each indicating the presence or absence of a capability. The commands associated with each capability will return the NOT_IMPLEMENTED error if the cabability is not available. Since JDWP version 1.4.

  See Also:
    Constant Field Values

### VirtualMachine_RedefineClassesCOMMAND

    public static final int VirtualMachine_RedefineClassesCOMMAND

  Installs new class definitions.

  See Also:
    Constant Field Values

### VirtualMachine_SetDefaultStratum_COMMAND

    public static final int VirtualMachine_SetDefaultStratum_COMMAND

  Set the default stratum.

  See Also:
    Constant Field Values

### VirtualMachine_AllClassesWithGeneric_COMMAND

    public static final int VirtualMachine_AllClassesWithGeneric_COMMAND

  Returns reference types for all classes currently loaded by the target VM. Both the JNI signature and the generic signature are returned for each class. Generic signatures are described in the signature attribute section in the Java Virtual Machine Specification, 3rd Edition. Since JDWP version 1.5.

  See Also:
    Constant Field Values

### ReferenceType_COMMAND_SET

    public static final int ReferenceType_COMMAND_SET

See Also:
  Constant Field Values

### ReferenceType_Signature_COMMAND

    public static final int ReferenceType_Signature_COMMAND

  Returns the JNI signature of a reference type. JNI signature formats are described in the Java Native Inteface Specification

  For primitive classes the returned signature is the signature of the corresponding primitive type; for example, "I" is returned as the signature of the class represented by java.lang.Integer.TYPE.

  See Also:
    Constant Field Values

### ReferenceType_ClassLoader_COMMAND

    public static final int ReferenceType_ClassLoader_COMMAND

  Returns the instance of java.lang.ClassLoader which loaded a given reference type. If the reference type was loaded by the system class loader, the returned object ID is null.

  See Also:
    Constant Field Values

### ReferenceType_Modifiers_COMMAND

    public static final int ReferenceType_Modifiers_COMMAND

  Returns the modifiers (also known as access flags) for a reference type. The returned bit mask contains information on the declaration of the reference type. If the reference type is an array or a primitive class (for example, java.lang.Integer.TYPE), the value of the returned bit mask is undefined.

  See Also:
    Constant Field Values

### ReferenceType_Fields_COMMAND

    public static final int ReferenceType_Fields_COMMAND

  Returns information for each field in a reference type. Inherited fields are not included. The field list will include any synthetic fields created by the compiler. Fields are returned in the order they occur in the class file.

  See Also:
    Constant Field Values

### ReferenceType_Methods_COMMAND

    public static final int ReferenceType_Methods_COMMAND

  Returns information for each method in a reference type. Inherited methods are not included. The list of methods will include constructors (identified with the name "<init>"), the initialization method (identified with the name "<clinit>") if present, and any synthetic methods created by the compiler. Methods are returned in the order they occur in the class file.

  See Also:
    Constant Field Values

### ReferenceType_GetValues_COMMAND

    public static final int ReferenceType_GetValues_COMMAND

  Returns the value of one or more static fields of the reference type. Each field must be member of the reference type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, the values of private fields can be obtained.

  See Also:
    Constant Field Values

### ReferenceType_SourceFile_COMMAND

    public static final int ReferenceType_SourceFile_COMMAND

  Returns the name of source file in which a reference type was declared.

  See Also:
    Constant Field Values

### ReferenceType_NestedTypes_COMMAND

    public static final int ReferenceType_NestedTypes_COMMAND

  Returns the classes and interfaces directly nested within this type. Types further nested within those types are not included.

  See Also:
    Constant Field Values

### ReferenceType_Status_COMMAND

    public static final int ReferenceType_Status_COMMAND

  Returns the current status of the reference type. The status indicates the extent to which the reference type has been initialized, as described in the VM specification. The returned status bits are undefined for array types and for primitive classes (such as java.lang.Integer.TYPE).

  See Also:
    Constant Field Values

### ReferenceType_Interfaces_COMMAND

    public static final int ReferenceType_Interfaces_COMMAND

  Returns the interfaces declared as implemented by this class. Interfaces indirectly implemented (extended by the implemented interface or implemented by a superclass) are not included.

  See Also:
    Constant Field Values

### ReferenceType_ClassObject_COMMAND

    public static final int ReferenceType_ClassObject_COMMAND

  Returns the class object corresponding to this type.

  See Also:
    Constant Field Values

### ReferenceType_SourceDebugExtension_COMMAND

    public static final int ReferenceType_SourceDebugExtension_COMMAND

  Returns the value of the SourceDebugExtension attribute. Since JDWP version 1.4.

  See Also:
    Constant Field Values

### ReferenceType_SignatureWithGeneric_COMMAND

    public static final int ReferenceType_SignatureWithGeneric_COMMAND

  Returns the JNI signature of a reference type along with the generic signature if there is one. Generic signatures are described in the signature attribute section in the Java Virtual Machine Specification, 3rd Edition. Since JDWP version 1.5.

  See Also:
    Constant Field Values

### ReferenceType_FieldsWithGeneric_COMMAND

    public static final int ReferenceType_FieldsWithGeneric_COMMAND

  Returns information, including the generic signature if any, for each field in a reference type. Inherited fields are not included. The field list will include any synthetic fields created by the compiler. Fields are returned in the order they occur in the class file. Generic signatures are described in the signature attribute section in the Java Virtual Machine Specification, 3rd Edition. Since JDWP version 1.5.

  See Also:
    Constant Field Values

### ReferenceType_MethodsWithGeneric_COMMAND

    public static final int ReferenceType_MethodsWithGeneric_COMMAND

  Returns information, including the generic signature if any, for each method in a reference type. Inherited methodss are not included. The list of methods will include constructors (identified with the name "<init>"), the initialization method (identified with the name "<clinit>") if present, and any synthetic methods created by the compiler. Methods are returned in the order they occur in the class file. Generic signatures are described in the signature attribute section in the Java Virtual Machine Specification, 3rd Edition. Since JDWP version 1.5.

  See Also:
    Constant Field Values

### ClassType_COMMAND_SET

    public static final int ClassType_COMMAND_SET

See Also:
  Constant Field Values

### ClassType_Superclass_COMMAND

    public static final int ClassType_Superclass_COMMAND

  Returns the immediate superclass of a class.

  See Also:
    Constant Field Values

### ClassType_SetValues_COMMAND

    public static final int ClassType_SetValues_COMMAND

  Sets the value of one or more static fields. Each field must be member of the class type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, the values of private fields can be set. Final fields cannot be set. For primitive values, the value's type must match the field's type exactly. For object values, there must exist a widening reference conversion from the value's type to the field's type and the field's type must be loaded.

  See Also:
    Constant Field Values

### ClassType_InvokeMethod_COMMAND

    public static final int ClassType_InvokeMethod_COMMAND

  Invokes a static method. The method must be member of the class type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, private methods can be invoked.

  The method invocation will occur in the specified thread. Method invocation can occur only if the specified thread has been suspended by an event. Method invocation is not supported when the target VM has been suspended by the front-end.

  The specified method is invoked with the arguments in the specified argument list. The method invocation is synchronous; the reply packet is not sent until the invoked method returns in the target VM. The return value (possibly the void value) is included in the reply packet. If the invoked method throws an exception, the exception object ID is set in the reply packet; otherwise, the exception object ID is null.

  For primitive arguments, the argument value's type must match the argument's type exactly. For object arguments, there must exist a widening reference conversion from the argument value's type to the argument's type and the argument's type must be loaded.

  By default, all threads in the target VM are resumed while the method is being invoked if they were previously suspended by an event or by command. This is done to prevent the deadlocks that will occur if any of the threads own monitors that will be needed by the invoked method. It is possible that breakpoints or other events might occur during the invocation. Note, however, that this implicit resume acts exactly like the ThreadReference resume command, so if the thread's suspend count is greater than 1, it will remain in a suspended state during the invocation. By default, when the invocation completes, all threads in the target VM are suspended, regardless their state before the invocation.

  The resumption of other threads during the invoke can be prevented by specifying the INVOKE_SINGLE_THREADED bit flag in the `options` field; however, there is no protection against or recovery from the deadlocks described above, so this option should be used with great caution. Only the specified thread will be resumed (as described for all threads above). Upon completion of a single threaded invoke, the invoking thread will be suspended once again. Note that any threads started during the single threaded invocation will not be suspended when the invocation completes.

  If the target VM is disconnected during the invoke (for example, through the VirtualMachine dispose command) the method invocation continues.

  See Also:
    Constant Field Values

### ClassType_NewInstance_COMMAND

    public static final int ClassType_NewInstance_COMMAND

  Creates a new object of this type, invoking the specified constructor. The constructor method ID must be a member of the class type.

  Instance creation will occur in the specified thread. Instance creation can occur only if the specified thread has been suspended by an event. Method invocation is not supported when the target VM has been suspended by the front-end.

  The specified constructor is invoked with the arguments in the specified argument list. The constructor invocation is synchronous; the reply packet is not sent until the invoked method returns in the target VM. The return value (possibly the void value) is included in the reply packet. If the constructor throws an exception, the exception object ID is set in the reply packet; otherwise, the exception object ID is null.

  For primitive arguments, the argument value's type must match the argument's type exactly. For object arguments, there must exist a widening reference conversion from the argument value's type to the argument's type and the argument's type must be loaded.

  By default, all threads in the target VM are resumed while the method is being invoked if they were previously suspended by an event or by command. This is done to prevent the deadlocks that will occur if any of the threads own monitors that will be needed by the invoked method. It is possible that breakpoints or other events might occur during the invocation. Note, however, that this implicit resume acts exactly like the ThreadReference resume command, so if the thread's suspend count is greater than 1, it will remain in a suspended state during the invocation. By default, when the invocation completes, all threads in the target VM are suspended, regardless their state before the invocation.

  The resumption of other threads during the invoke can be prevented by specifying the INVOKE_SINGLE_THREADED bit flag in the `options` field; however, there is no protection against or recovery from the deadlocks described above, so this option should be used with great caution. Only the specified thread will be resumed (as described for all threads above). Upon completion of a single threaded invoke, the invoking thread will be suspended once again. Note that any threads started during the single threaded invocation will not be suspended when the invocation completes.

  If the target VM is disconnected during the invoke (for example, through the VirtualMachine dispose command) the method invocation continues.

  See Also:
    Constant Field Values

### ArrayType_COMMAND_SET

    public static final int ArrayType_COMMAND_SET

See Also:
  Constant Field Values

### ArrayType_NewInstance_COMMAND

    public static final int ArrayType_NewInstance_COMMAND

  Creates a new array object of this type with a given length.

  See Also:
    Constant Field Values

### InterfaceType_COMMAND_SET

    public static final int InterfaceType_COMMAND_SET

See Also:
  Constant Field Values

### Method_COMMAND_SET

    public static final int Method_COMMAND_SET

See Also:
  Constant Field Values

### Method_LineTable_COMMAND

    public static final int Method_LineTable_COMMAND

  Returns line number information for the method. The line table maps source line numbers to the initial code index of the line. The line table is ordered by code index (from lowest to highest).

  See Also:
    Constant Field Values

### Method_VariableTable_COMMAND

    public static final int Method_VariableTable_COMMAND

  Returns variable information for the method. The variable table includes arguments and locals declared within the method. For instance methods, the "this" reference is included in the table. Also, synthetic variables may be present.

  See Also:
    Constant Field Values

### Method_Bytecodes_COMMAND

    public static final int Method_Bytecodes_COMMAND

  Retrieve the method's bytecodes as defined in the JVM Specification.

  See Also:
    Constant Field Values

### Method_IsObsolete_COMMAND

    public static final int Method_IsObsolete_COMMAND

  Determine if this method is obsolete.

  See Also:
    Constant Field Values

### Method_VariableTableWithGeneric_COMMAND

    public static final int Method_VariableTableWithGeneric_COMMAND

  Returns variable information for the method, including generic signatures for the variables. The variable table includes arguments and locals declared within the method. For instance methods, the "this" reference is included in the table. Also, synthetic variables may be present. Generic signatures are described in the signature attribute section in the Java Virtual Machine Specification, 3rd Edition. Since JDWP version 1.5.

  See Also:
    Constant Field Values

### Field_COMMAND_SET

    public static final int Field_COMMAND_SET

See Also:
  Constant Field Values

### ObjectReference_COMMAND_SET

    public static final int ObjectReference_COMMAND_SET

See Also:
  Constant Field Values

### ObjectReference_ReferenceType_COMMAND

    public static final int ObjectReference_ReferenceType_COMMAND

  Returns the runtime type of the object. The runtime type will be a class or an array.

  See Also:
    Constant Field Values

### ObjectReference_GetValues_COMMAND

    public static final int ObjectReference_GetValues_COMMAND

  Returns the value of one or more instance fields. Each field must be member of the object's type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, the values of private fields can be obtained.

  See Also:
    Constant Field Values

### ObjectReference_SetValues_COMMAND

    public static final int ObjectReference_SetValues_COMMAND

  Sets the value of one or more instance fields. Each field must be member of the object's type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, the values of private fields can be set. For primitive values, the value's type must match the field's type exactly. For object values, there must be a widening reference conversion from the value's type to the field's type and the field's type must be loaded.

  See Also:
    Constant Field Values

### ObjectReference_MonitorInfo_COMMAND

    public static final int ObjectReference_MonitorInfo_COMMAND

  Returns monitor information for an object. All threads int the VM must be suspended.

  See Also:
    Constant Field Values

### ObjectReference_InvokeMethod_COMMAND

    public static final int ObjectReference_InvokeMethod_COMMAND

  Invokes a instance method. The method must be member of the object's type or one of its superclasses, superinterfaces, or implemented interfaces. Access control is not enforced; for example, private methods can be invoked.

  The method invocation will occur in the specified thread. Method invocation can occur only if the specified thread has been suspended by an event. Method invocation is not supported when the target VM has been suspended by the front-end.

  The specified method is invoked with the arguments in the specified argument list. The method invocation is synchronous; the reply packet is not sent until the invoked method returns in the target VM. The return value (possibly the void value) is included in the reply packet. If the invoked method throws an exception, the exception object ID is set in the reply packet; otherwise, the exception object ID is null.

  For primitive arguments, the argument value's type must match the argument's type exactly. For object arguments, there must be a widening reference conversion from the argument value's type to the argument's type and the argument's type must be loaded.

  By default, all threads in the target VM are resumed while the method is being invoked if they were previously suspended by an event or by command. This is done to prevent the deadlocks that will occur if any of the threads own monitors that will be needed by the invoked method. It is possible that breakpoints or other events might occur during the invocation. Note, however, that this implicit resume acts exactly like the ThreadReference resume command, so if the thread's suspend count is greater than 1, it will remain in a suspended state during the invocation. By default, when the invocation completes, all threads in the target VM are suspended, regardless their state before the invocation.

  The resumption of other threads during the invoke can be prevented by specifying the INVOKE_SINGLE_THREADED bit flag in the `options` field; however, there is no protection against or recovery from the deadlocks described above, so this option should be used with great caution. Only the specified thread will be resumed (as described for all threads above). Upon completion of a single threaded invoke, the invoking thread will be suspended once again. Note that any threads started during the single threaded invocation will not be suspended when the invocation completes.

  If the target VM is disconnected during the invoke (for example, through the VirtualMachine dispose command) the method invocation continues.

  See Also:
    Constant Field Values

### ObjectReference_DisableCollection_COMMAND

    public static final int ObjectReference_DisableCollection_COMMAND

  Prevents garbage collection for the given object. By default all objects in back-end replies may be collected at any time the target VM is running. A call to this command guarantees that the object will not be collected. The EnableCollection command can be used to allow collection once again.

  Note that while the target VM is suspended, no garbage collection will occur because all threads are suspended. The typical examination of variables, fields, and arrays during the suspension is safe without explicitly disabling garbage collection.

  This method should be used sparingly, as it alters the pattern of garbage collection in the target VM and, consequently, may result in application behavior under the debugger that differs from its non-debugged behavior.

  See Also:
    Constant Field Values

### ObjectReference_EnableCollection_COMMAND

    public static final int ObjectReference_EnableCollection_COMMAND

  Permits garbage collection for this object. By default all objects returned by the JDWP may be collected at any time the target VM is running. A call to this command is necessary only if garbage collection was previously disabled with the DisableCollection command.

  See Also:
    Constant Field Values

### ObjectReference_IsCollected_COMMAND

    public static final int ObjectReference_IsCollected_COMMAND

  Determines whether an object has been garbage collected in the target VM.

  See Also:
    Constant Field Values

### StringReference_COMMAND_SET

    public static final int StringReference_COMMAND_SET

See Also:
  Constant Field Values

### StringReference_Value_COMMAND

    public static final int StringReference_Value_COMMAND

  Returns the characters contained in the string.

  See Also:
    Constant Field Values

### ThreadReference_COMMAND_SET

    public static final int ThreadReference_COMMAND_SET

See Also:
  Constant Field Values

### ThreadReference_Name_COMMAND

    public static final int ThreadReference_Name_COMMAND

  Returns the thread name.

  See Also:
    Constant Field Values

### ThreadReference_Suspend_COMMAND

    public static final int ThreadReference_Suspend_COMMAND

  Suspends the thread.

  Unlike java.lang.Thread.suspend(), suspends of both the virtual machine and individual threads are counted. Before a thread will run again, it must be resumed the same number of times it has been suspended.

  Suspending single threads with command has the same dangers java.lang.Thread.suspend(). If the suspended thread holds a monitor needed by another running thread, deadlock is possible in the target VM (at least until the suspended thread is resumed again).

  The suspended thread is guaranteed to remain suspended until resumed through one of the JDI resume methods mentioned above; the application in the target VM cannot resume the suspended thread through `java.lang.Thread#resume`.

  Note that this doesn't change the status of the thread (see the ThreadStatus command.) For example, if it was Running, it will still appear running to other threads.

  See Also:
    Constant Field Values

### ThreadReference_Resume_COMMAND

    public static final int ThreadReference_Resume_COMMAND

  Resumes the execution of a given thread. If this thread was not previously suspended by the front-end, calling this command has no effect. Otherwise, the count of pending suspends on this thread is decremented. If it is decremented to 0, the thread will continue to execute.

  See Also:
    Constant Field Values

### ThreadReference_Status_COMMAND

    public static final int ThreadReference_Status_COMMAND

  Returns the current status of a thread. The thread status reply indicates the thread status the last time it was running. the suspend status provides information on the thread's suspension, if any.

  See Also:
    Constant Field Values

### ThreadReference_ThreadGroup_COMMAND

    public static final int ThreadReference_ThreadGroup_COMMAND

  Returns the thread group that contains a given thread.

  See Also:
    Constant Field Values

### ThreadReference_Frames_COMMAND

    public static final int ThreadReference_Frames_COMMAND

  Returns the current call stack of a suspended thread. The sequence of frames starts with the currently executing frame, followed by its caller, and so on. The thread must be suspended, and the returned frameID is valid only while the thread is suspended.

  See Also:
    Constant Field Values

### ThreadReference_FrameCount_COMMAND

    public static final int ThreadReference_FrameCount_COMMAND

  Returns the count of frames on this thread's stack. The thread must be suspended, and the returned count is valid only while the thread is suspended. Returns JDWP.Event_errorThreadNotSuspended if not suspended.

  See Also:
    Constant Field Values

### ThreadReference_OwnedMonitors_COMMAND

    public static final int ThreadReference_OwnedMonitors_COMMAND

  Returns the objects whose monitors have been entered by this thread. The thread must be suspended, and the returned information is relevant only while the thread is suspended.

  See Also:
    Constant Field Values

### ThreadReference_CurrentContendedMonitor_COMMAND

    public static final int ThreadReference_CurrentContendedMonitor_COMMAND

  Returns the object, if any, for which this thread is waiting for monitor entry or with java.lang.Object.wait. The thread must be suspended, and the returned information is relevant only while the thread is suspended.

  See Also:
    Constant Field Values

### ThreadReference_Stop_COMMAND

    public static final int ThreadReference_Stop_COMMAND

  Stops the thread with an asynchronous exception, as if done by java.lang.Thread.stop

  See Also:
    Constant Field Values

### ThreadReference_Interrupt_COMMAND

    public static final int ThreadReference_Interrupt_COMMAND

  Interrupt the thread, as if done by java.lang.Thread.interrupt

  See Also:
    Constant Field Values

### ThreadReference_SuspendCount_COMMAND

    public static final int ThreadReference_SuspendCount_COMMAND

  Get the suspend count for this thread. The suspend count is the number of times the thread has been suspended through the thread-level or VM-level suspend commands without a corresponding resume

  See Also:
    Constant Field Values

### ThreadGroupReference_COMMAND_SET

    public static final int ThreadGroupReference_COMMAND_SET

See Also:
  Constant Field Values

### ThreadGroupReference_Name_COMMAND

    public static final int ThreadGroupReference_Name_COMMAND

  Returns the thread group name.

  See Also:
    Constant Field Values

### ThreadGroupReference_Parent_COMMAND

    public static final int ThreadGroupReference_Parent_COMMAND

  Returns the thread group, if any, which contains a given thread group.

  See Also:
    Constant Field Values

### ThreadGroupReference_Children_COMMAND

    public static final int ThreadGroupReference_Children_COMMAND

  Returns the threads and thread groups directly contained in this thread group. Threads and thread groups in child thread groups are not included.

  See Also:
    Constant Field Values

### ArrayReference_COMMAND_SET

    public static final int ArrayReference_COMMAND_SET

See Also:
  Constant Field Values

### ArrayReference_Length_COMMAND

    public static final int ArrayReference_Length_COMMAND

  Returns the number of components in a given array.

  See Also:
    Constant Field Values

### ArrayReference_GetValues_COMMAND

    public static final int ArrayReference_GetValues_COMMAND

  Returns a range of array components. The specified range must be within the bounds of the array.

  See Also:
    Constant Field Values

### ArrayReference_SetValues_COMMAND

    public static final int ArrayReference_SetValues_COMMAND

  Sets a range of array components. The specified range must be within the bounds of the array. For primitive values, each value's type must match the array component type exactly. For object values, there must be a widening reference conversion from the value's type to the array component type and the array component type must be loaded.

  See Also:
    Constant Field Values

### ClassLoaderReference_COMMAND_SET

    public static final int ClassLoaderReference_COMMAND_SET

See Also:
  Constant Field Values

### ClassLoaderReference_VisibleClasses_COMMAND

    public static final int ClassLoaderReference_VisibleClasses_COMMAND

  Returns a list of all classes which this class loader has been requested to load. This class loader is considered to be an initiating class loader for each class in the returned list. The list contains each reference type defined by this loader and any types for which loading was delegated by this class loader to another class loader.

  The visible class list has useful properties with respect to the type namespace. A particular type name will occur at most once in the list. Each field or variable declared with that type name in a class defined by this class loader must be resolved to that single type.

  No ordering of the returned list is guaranteed.

  See Also:
    Constant Field Values

### EventRequest_COMMAND_SET

    public static final int EventRequest_COMMAND_SET

See Also:
  Constant Field Values

### EventRequest_Set_COMMAND

    public static final int EventRequest_Set_COMMAND

  Set an event request. When the event described by this request occurs, an event is sent from the target VM.

  See Also:
    Constant Field Values

### EventRequest_Clear_COMMAND

    public static final int EventRequest_Clear_COMMAND

  Clear an event request.

  See Also:
    Constant Field Values

### EventRequest_ClearAllBreakpoints_COMMAND

    public static final int EventRequest_ClearAllBreakpoints_COMMAND

  Removes all set breakpoints.

  See Also:
    Constant Field Values

### EventRequest_MOD_COUNT

    public static final int EventRequest_MOD_COUNT

  Modifier kind values that make events conditional. Most are NOT supported by SDWP or Squawk.

  See Also:
    Constant Field Values

### EventRequest_MOD_CONDITIONAL

    public static final int EventRequest_MOD_CONDITIONAL

See Also:
  Constant Field Values

### EventRequest_MOD_THREAD_ONLY

    public static final int EventRequest_MOD_THREAD_ONLY

See Also:
  Constant Field Values

### EventRequest_MOD_CLASS_ONLY

    public static final int EventRequest_MOD_CLASS_ONLY

See Also:
  Constant Field Values

### EventRequest_MOD_CLASS_MATCH

    public static final int EventRequest_MOD_CLASS_MATCH

See Also:
  Constant Field Values

### EventRequest_MOD_CLASS_EXCLUDE

    public static final int EventRequest_MOD_CLASS_EXCLUDE

See Also:
  Constant Field Values

### EventRequest_MOD_LOCATION_ONLY

    public static final int EventRequest_MOD_LOCATION_ONLY

See Also:
  Constant Field Values

### EventRequest_MOD_EXCEPTION_ONLY

    public static final int EventRequest_MOD_EXCEPTION_ONLY

See Also:
  Constant Field Values

### EventRequest_MOD_FIELD_ONLY

    public static final int EventRequest_MOD_FIELD_ONLY

See Also:
  Constant Field Values

### EventRequest_MOD_STEP

    public static final int EventRequest_MOD_STEP

See Also:
  Constant Field Values

### EventRequest_MOD_INSTANCE_ONLY

    public static final int EventRequest_MOD_INSTANCE_ONLY

See Also:
  Constant Field Values

### StackFrame_COMMAND_SET

    public static final int StackFrame_COMMAND_SET

See Also:
  Constant Field Values

### StackFrame_GetValues_COMMAND

    public static final int StackFrame_GetValues_COMMAND

  Returns the value of one or more local variables in a given frame. Each variable must be visible at the frame's code index. Even if local variable information is not available, values can be retrieved if the front-end is able to determine the correct local variable index. (Typically, this index can be determined for method arguments from the method signature without access to the local variable table information.)

  See Also:
    Constant Field Values

### StackFrame_SetValues_COMMAND

    public static final int StackFrame_SetValues_COMMAND

  Sets the value of one or more local variables. Each variable must be visible at the current frame code index. For primitive values, the value's type must match the variable's type exactly. For object values, there must be a widening reference conversion from the value's type to the variable's type and the variable's type must be loaded.

  Even if local variable information is not available, values can be set, if the front-end is able to determine the correct local variable index. (Typically, this index can be determined for method arguments from the method signature without access to the local variable table information.)

  See Also:
    Constant Field Values

### StackFrame_ThisObject_COMMAND

    public static final int StackFrame_ThisObject_COMMAND

  Returns the value of the 'this' reference for this frame. If the frame's method is static or native, the reply will contain the null object reference.

  See Also:
    Constant Field Values

### StackFrame_PopFrames_COMMAND

    public static final int StackFrame_PopFrames_COMMAND

  Pop stack frames, thru and including 'frame'. Since JDWP version 1.4.

  See Also:
    Constant Field Values

### ClassObjectReference_COMMAND_SET

    public static final int ClassObjectReference_COMMAND_SET

See Also:
  Constant Field Values

### ClassObjectReference_ReflectedType_COMMAND

    public static final int ClassObjectReference_ReflectedType_COMMAND

  Returns the reference type reflected by this class object.

  See Also:
    Constant Field Values

### Event_COMMAND_SET

    public static final int Event_COMMAND_SET

See Also:
  Constant Field Values

### Event_Composite_COMMAND

    public static final int Event_Composite_COMMAND

  Several events may occur at a given time in the target VM. For example, there may be more than one breakpoint request for a given location or you might single step to the same location as a breakpoint request. These events are delivered together as a composite event. For uniformity, a composite event is always used to deliver events, even if there is only one event to report.

  The events that are grouped in a composite event are restricted in the following ways:

  - Always singleton composite events:
    - VM Start Event
    - VM Death Event
  - Only with other thread start events for the same thread:
    - Thread Start Event
  - Only with other thread death events for the same thread:
    - Thread Death Event
  - Only with other class prepare events for the same class:
    - Class Prepare Event}
  - Only with other class unload events for the same class:
    - Class Unload Event
  - Only with other access watchpoint events for the same field access:
    - Access Watchpoint Event
  - Only with other modification watchpoint events for the same field modification:
    - Modification Watchpoint Event
  - Only with other ExceptionEvents for the same exception occurrance:
    - ExceptionEvent
  - Only with other members of this group, at the same location and in the same thread:
    - Breakpoint Event
    - Step Event
    - Method Entry Event
    - Method Exit Event

  See Also:
    Constant Field Values

### Error_NONE

    public static final int Error_NONE

See Also:
  Constant Field Values

### Error_INVALID_THREAD

    public static final int Error_INVALID_THREAD

See Also:
  Constant Field Values

### Error_INVALID_THREAD_GROUP

    public static final int Error_INVALID_THREAD_GROUP

See Also:
  Constant Field Values

### Error_INVALID_PRIORITY

    public static final int Error_INVALID_PRIORITY

See Also:
  Constant Field Values

### Error_THREAD_NOT_SUSPENDED

    public static final int Error_THREAD_NOT_SUSPENDED

See Also:
  Constant Field Values

### Error_THREAD_SUSPENDED

    public static final int Error_THREAD_SUSPENDED

See Also:
  Constant Field Values

### Error_INVALID_OBJECT

    public static final int Error_INVALID_OBJECT

See Also:
  Constant Field Values

### Error_INVALID_CLASS

    public static final int Error_INVALID_CLASS

See Also:
  Constant Field Values

### Error_CLASS_NOT_PREPARED

    public static final int Error_CLASS_NOT_PREPARED

See Also:
  Constant Field Values

### Error_INVALID_METHODID

    public static final int Error_INVALID_METHODID

See Also:
  Constant Field Values

### Error_INVALID_LOCATION

    public static final int Error_INVALID_LOCATION

See Also:
  Constant Field Values

### Error_INVALID_FIELDID

    public static final int Error_INVALID_FIELDID

See Also:
  Constant Field Values

### Error_INVALID_FRAMEID

    public static final int Error_INVALID_FRAMEID

See Also:
  Constant Field Values

### Error_NO_MORE_FRAMES

    public static final int Error_NO_MORE_FRAMES

See Also:
  Constant Field Values

### Error_OPAQUE_FRAME

    public static final int Error_OPAQUE_FRAME

See Also:
  Constant Field Values

### Error_NOT_CURRENT_FRAME

    public static final int Error_NOT_CURRENT_FRAME

See Also:
  Constant Field Values

### Error_TYPE_MISMATCH

    public static final int Error_TYPE_MISMATCH

See Also:
  Constant Field Values

### Error_INVALID_SLOT

    public static final int Error_INVALID_SLOT

See Also:
  Constant Field Values

### Error_DUPLICATE

    public static final int Error_DUPLICATE

See Also:
  Constant Field Values

### Error_NOT_FOUND

    public static final int Error_NOT_FOUND

See Also:
  Constant Field Values

### Error_INVALID_MONITOR

    public static final int Error_INVALID_MONITOR

See Also:
  Constant Field Values

### Error_NOT_MONITOR_OWNER

    public static final int Error_NOT_MONITOR_OWNER

See Also:
  Constant Field Values

### Error_INTERRUPT

    public static final int Error_INTERRUPT

See Also:
  Constant Field Values

### Error_INVALID_CLASS_FORMAT

    public static final int Error_INVALID_CLASS_FORMAT

See Also:
  Constant Field Values

### Error_CIRCULAR_CLASS_DEFINITION

    public static final int Error_CIRCULAR_CLASS_DEFINITION

See Also:
  Constant Field Values

### Error_FAILS_VERIFICATION

    public static final int Error_FAILS_VERIFICATION

See Also:
  Constant Field Values

### Error_ADD_METHOD_NOT_IMPLEMENTED

    public static final int Error_ADD_METHOD_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_SCHEMA_CHANGE_NOT_IMPLEMENTED

    public static final int Error_SCHEMA_CHANGE_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_INVALID_TYPESTATE

    public static final int Error_INVALID_TYPESTATE

See Also:
  Constant Field Values

### Error_HIERARCHY_CHANGE_NOT_IMPLEMENTED

    public static final int Error_HIERARCHY_CHANGE_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_DELETE_METHOD_NOT_IMPLEMENTED

    public static final int Error_DELETE_METHOD_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_UNSUPPORTED_VERSION

    public static final int Error_UNSUPPORTED_VERSION

See Also:
  Constant Field Values

### Error_NAMES_DONT_MATCH

    public static final int Error_NAMES_DONT_MATCH

See Also:
  Constant Field Values

### Error_CLASS_MODIFIERS_CHANGE_NOT_IMPLEMENTED

    public static final int Error_CLASS_MODIFIERS_CHANGE_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_METHOD_MODIFIERS_CHANGE_NOT_IMPLEMENTED

    public static final int Error_METHOD_MODIFIERS_CHANGE_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_NOT_IMPLEMENTED

    public static final int Error_NOT_IMPLEMENTED

See Also:
  Constant Field Values

### Error_NULL_POINTER

    public static final int Error_NULL_POINTER

See Also:
  Constant Field Values

### Error_ABSENT_INFORMATION

    public static final int Error_ABSENT_INFORMATION

See Also:
  Constant Field Values

### Error_INVALID_EVENT_TYPE

    public static final int Error_INVALID_EVENT_TYPE

See Also:
  Constant Field Values

### Error_ILLEGAL_ARGUMENT

    public static final int Error_ILLEGAL_ARGUMENT

See Also:
  Constant Field Values

### Error_OUT_OF_MEMORY

    public static final int Error_OUT_OF_MEMORY

See Also:
  Constant Field Values

### Error_ACCESS_DENIED

    public static final int Error_ACCESS_DENIED

See Also:
  Constant Field Values

### Error_VM_DEAD

    public static final int Error_VM_DEAD

See Also:
  Constant Field Values

### Error_INTERNAL

    public static final int Error_INTERNAL

See Also:
  Constant Field Values

### Error_UNATTACHED_THREAD

    public static final int Error_UNATTACHED_THREAD

See Also:
  Constant Field Values

### Error_INVALID_TAG

    public static final int Error_INVALID_TAG

See Also:
  Constant Field Values

### Error_ALREADY_INVOKING

    public static final int Error_ALREADY_INVOKING

See Also:
  Constant Field Values

### Error_INVALID_INDEX

    public static final int Error_INVALID_INDEX

See Also:
  Constant Field Values

### Error_INVALID_LENGTH

    public static final int Error_INVALID_LENGTH

See Also:
  Constant Field Values

### Error_INVALID_STRING

    public static final int Error_INVALID_STRING

See Also:
  Constant Field Values

### Error_INVALID_CLASS_LOADER

    public static final int Error_INVALID_CLASS_LOADER

See Also:
  Constant Field Values

### Error_INVALID_ARRAY

    public static final int Error_INVALID_ARRAY

See Also:
  Constant Field Values

### Error_TRANSPORT_LOAD

    public static final int Error_TRANSPORT_LOAD

See Also:
  Constant Field Values

### Error_TRANSPORT_INIT

    public static final int Error_TRANSPORT_INIT

See Also:
  Constant Field Values

### Error_NATIVE_METHOD

    public static final int Error_NATIVE_METHOD

See Also:
  Constant Field Values

### Error_INVALID_COUNT

    public static final int Error_INVALID_COUNT

See Also:
  Constant Field Values

### EventKind_VM_DISCONNECTED

    public static final int EventKind_VM_DISCONNECTED

See Also:
  Constant Field Values

### EventKind_VM_START

    public static final int EventKind_VM_START

See Also:
  Constant Field Values

### EventKind_THREAD_DEATH

    public static final int EventKind_THREAD_DEATH

See Also:
  Constant Field Values

### EventKind_SINGLE_STEP

    public static final int EventKind_SINGLE_STEP

See Also:
  Constant Field Values

### EventKind_BREAKPOINT

    public static final int EventKind_BREAKPOINT

See Also:
  Constant Field Values

### EventKind_FRAME_POP

    public static final int EventKind_FRAME_POP

See Also:
  Constant Field Values

### EventKind_EXCEPTION

    public static final int EventKind_EXCEPTION

See Also:
  Constant Field Values

### EventKind_USER_DEFINED

    public static final int EventKind_USER_DEFINED

See Also:
  Constant Field Values

### EventKind_THREAD_START

    public static final int EventKind_THREAD_START

See Also:
  Constant Field Values

### EventKind_THREAD_END

    public static final int EventKind_THREAD_END

See Also:
  Constant Field Values

### EventKind_CLASS_PREPARE

    public static final int EventKind_CLASS_PREPARE

See Also:
  Constant Field Values

### EventKind_CLASS_UNLOAD

    public static final int EventKind_CLASS_UNLOAD

See Also:
  Constant Field Values

### EventKind_CLASS_LOAD

    public static final int EventKind_CLASS_LOAD

See Also:
  Constant Field Values

### EventKind_FIELD_ACCESS

    public static final int EventKind_FIELD_ACCESS

See Also:
  Constant Field Values

### EventKind_FIELD_MODIFICATION

    public static final int EventKind_FIELD_MODIFICATION

See Also:
  Constant Field Values

### EventKind_EXCEPTION_CATCH

    public static final int EventKind_EXCEPTION_CATCH

See Also:
  Constant Field Values

### EventKind_METHOD_ENTRY

    public static final int EventKind_METHOD_ENTRY

See Also:
  Constant Field Values

### EventKind_METHOD_EXIT

    public static final int EventKind_METHOD_EXIT

See Also:
  Constant Field Values

### EventKind_VM_INIT

    public static final int EventKind_VM_INIT

See Also:
  Constant Field Values

### EventKind_VM_DEATH

    public static final int EventKind_VM_DEATH

See Also:
  Constant Field Values

### ThreadStatus_ZOMBIE

    public static final int ThreadStatus_ZOMBIE

See Also:
  Constant Field Values

### ThreadStatus_RUNNING

    public static final int ThreadStatus_RUNNING

See Also:
  Constant Field Values

### ThreadStatus_SLEEPING

    public static final int ThreadStatus_SLEEPING

See Also:
  Constant Field Values

### ThreadStatus_MONITOR

    public static final int ThreadStatus_MONITOR

See Also:
  Constant Field Values

### ThreadStatus_WAIT

    public static final int ThreadStatus_WAIT

See Also:
  Constant Field Values

### SuspendStatus_SUSPEND_STATUS_SUSPENDED

    public static final int SuspendStatus_SUSPEND_STATUS_SUSPENDED

See Also:
  Constant Field Values

### ClassStatus_VERIFIED

    public static final int ClassStatus_VERIFIED

See Also:
  Constant Field Values

### ClassStatus_PREPARED

    public static final int ClassStatus_PREPARED

See Also:
  Constant Field Values

### ClassStatus_INITIALIZED

    public static final int ClassStatus_INITIALIZED

See Also:
  Constant Field Values

### ClassStatus_ERROR

    public static final int ClassStatus_ERROR

See Also:
  Constant Field Values

### ClassStatus_VERIFIED_PREPARED_INITIALIZED

    public static final int ClassStatus_VERIFIED_PREPARED_INITIALIZED

See Also:
  Constant Field Values

### TypeTag_CLASS

    public static final int TypeTag_CLASS

See Also:
  Constant Field Values

### TypeTag_INTERFACE

    public static final int TypeTag_INTERFACE

See Also:
  Constant Field Values

### TypeTag_ARRAY

    public static final int TypeTag_ARRAY

See Also:
  Constant Field Values

### Tag_ARRAY

    public static final int Tag_ARRAY

See Also:
  Constant Field Values

### Tag_BYTE

    public static final int Tag_BYTE

See Also:
  Constant Field Values

### Tag_CHAR

    public static final int Tag_CHAR

See Also:
  Constant Field Values

### Tag_OBJECT

    public static final int Tag_OBJECT

See Also:
  Constant Field Values

### Tag_FLOAT

    public static final int Tag_FLOAT

See Also:
  Constant Field Values

### Tag_DOUBLE

    public static final int Tag_DOUBLE

See Also:
  Constant Field Values

### Tag_INT

    public static final int Tag_INT

See Also:
  Constant Field Values

### Tag_LONG

    public static final int Tag_LONG

See Also:
  Constant Field Values

### Tag_SHORT

    public static final int Tag_SHORT

See Also:
  Constant Field Values

### Tag_VOID

    public static final int Tag_VOID

See Also:
  Constant Field Values

### Tag_BOOLEAN

    public static final int Tag_BOOLEAN

See Also:
  Constant Field Values

### Tag_STRING

    public static final int Tag_STRING

See Also:
  Constant Field Values

### Tag_THREAD

    public static final int Tag_THREAD

See Also:
  Constant Field Values

### Tag_THREAD_GROUP

    public static final int Tag_THREAD_GROUP

See Also:
  Constant Field Values

### Tag_CLASS_LOADER

    public static final int Tag_CLASS_LOADER

See Also:
  Constant Field Values

### Tag_CLASS_OBJECT

    public static final int Tag_CLASS_OBJECT

See Also:
  Constant Field Values

### StepDepth_INTO

    public static final int StepDepth_INTO

See Also:
  Constant Field Values

### StepDepth_OVER

    public static final int StepDepth_OVER

See Also:
  Constant Field Values

### StepDepth_OUT

    public static final int StepDepth_OUT

See Also:
  Constant Field Values

### StepSize_MIN

    public static final int StepSize_MIN

See Also:
  Constant Field Values

### StepSize_LINE

    public static final int StepSize_LINE

See Also:
  Constant Field Values

### SuspendPolicy_NONE

    public static final int SuspendPolicy_NONE

See Also:
  Constant Field Values

### SuspendPolicy_EVENT_THREAD

    public static final int SuspendPolicy_EVENT_THREAD

See Also:
  Constant Field Values

### SuspendPolicy_ALL

    public static final int SuspendPolicy_ALL

See Also:
  Constant Field Values

### InvokeOptions_INVOKE_SINGLE_THREADED

    public static final int InvokeOptions_INVOKE_SINGLE_THREADED

See Also:
  Constant Field Values

### InvokeOptions_INVOKE_NONVIRTUAL

    public static final int InvokeOptions_INVOKE_NONVIRTUAL

See Also:
  Constant Field Values

Method Detail

### getTypeTag

    public static byte getTypeTag(Klass klass)

  Gets the `JDWP.TypeTag_...` value corresponding to a given class.

  Parameters:
    `klass` - the class to convert
  Returns:
    the `JDWP.TypeTag_...` value corresponding to `klass`

### isValidTypeTag

    public static boolean isValidTypeTag(int typeTag)

  Return true if the tag is a valid JDWP Type Tag value. Type tags are a sparse set that doesn't include zero, so it's a good value to validate.

  Parameters:
    `typeTag` - int
  Returns:
    boolean

### getTag

    public static byte getTag(Klass klass)

  Given a klass, returns the corresponding `com.sun.squawk.debugger.JDWP.Tag` value.

  Parameters:
    `klass` - Klass
  Returns:
    the JDWP.Tag value

### isValidTag

    public static boolean isValidTag(int tag)

  Return true if the tag is a valid JDWP Tag value. Tags are a sparse set that doesn't include zero, so it's a good value to validate.

  Parameters:
    `tag` - int
  Returns:
    boolean

### isReferenceTag

    public static boolean isReferenceTag(int tag)

  Return true if the tag represents an reference type JDWP Tag value.

  Parameters:
    `tag` - int
  Returns:
    boolean

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

"
For updated information see the Java FRC site
"